/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"

#include <assert.h>

#include <stdio.h> // files
#include <io.h>

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <wchar.h>



void Module::sub_process(long buffer_offset, long sampleFrames )
{ 
	
	{
		CallHost(seaudioMasterSleepMode);
	}
	
	
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
 
	// system messages are for timing info etc
	// they don't have a channel, just pass them right through
	bool is_system_msg = ( midi_msg & SYSTEM_MSG ) == SYSTEM_MSG;
   
	
		/*
            int chan = midi_msg & 0x0f;  // CHAN
		    int stat = midi_msg & 0xf0;  // ON OFF
		    int b2 = ( midi_msg / 0x100 ) & 0xff;    //NOTE
		    int b3 = ( midi_msg / 0x10000 ) & 0xff;  //VEL   
			//REV=
			midi_msg = stat + chan + (b2 << 8) + (b3 << 16);
        */


    
	if( !is_system_msg )
	{
		  
		   	int chan = midi_msg & 0x0f;
            int stat = midi_msg & 0xf0;  // ON OFF
  /* switch( stat )
   {
		case NOTE_ON:
		case NOTE_OFF:
			{
*/
		    int b2 = ( midi_msg / 0x100 ) & 0xff;    //NOTE
		    int b3 = ( midi_msg / 0x10000 ) & 0xff;  //VEL   


   switch( chan )	     
   {
	case 0: chan = c1; break;
	case 1:	chan = c2; break;
    case 2: chan = c3; break;
	case 3:	chan = c4; break;
    case 4: chan = c5; break;
	case 5:	chan = c6; break;
    case 6: chan = c7; break;
	case 7:	chan = c8; break;
    case 8: chan = c9; break;
	case 9:	chan = c10; break;
    case 10: chan = c11; break;
	case 11: chan = c12; break;
    case 12: chan = c13; break;
	case 13: chan = c14; break;
    case 14: chan = c15; break;
	case 15: chan = c16; break;
   }
	 midi_msg = stat + (chan-1) + (b2 << 8) + (b3 << 16);
     getPin(chan+16)->TransmitMIDI(SampleClock(), midi_msg);		
//			}//note on off
 //  }//stat
		 				  
	}//system
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{   
	
	err2 = -1; err = -1;isnew = false;
	SEModule_base::open();
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	
	_fcloseall();
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{ 
   LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n",  "MIDI_CHAN_TRANS_SEP");
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2010 March    in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *    RECORDER for SMIDI Files       " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = dish.thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = dish.thisSEM;

	// Info, may include Author, Web page whatever
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;
  
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	case 0:
		properties->name				= "MIDI In";
		properties->direction			= DR_IN;
		properties->datatype			= DT_MIDI2;
		break;
	
    case 1:	
		properties->name				= "CH 1 ON";
		properties->variable_address	= &c1;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "1";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 2:	
		properties->name				= "CH 2 ON";
		properties->variable_address	= &c2;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "2";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 3:	
		properties->name				= "CH 3 ON";
		properties->variable_address	= &c3;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "3";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 4:	
		properties->name				= "CH 4 ON";
		properties->variable_address	= &c4;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "4";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 5:	
		properties->name				= "CH 5 ON";
		properties->variable_address	= &c5;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "5";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 6:	
		properties->name				= "CH 6 ON";
		properties->variable_address	= &c6;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "6";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 7:	
		properties->name				= "CH 7 ON";
		properties->variable_address	= &c7;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "7";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 8:	
		properties->name				= "CH 8 ON";
		properties->variable_address	= &c8;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "8";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 9:	
		properties->name				= "CH 9 ON";
		properties->variable_address	= &c9;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "9";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 10:	
		properties->name				= "CH 10 ON";
		properties->variable_address	= &c10;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "10";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 11:	
		properties->name				= "CH 11 ON";
		properties->variable_address	= &c11;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "11";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 12:	
		properties->name				= "CH 12 ON";
		properties->variable_address	= &c12;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "12";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 13:	
		properties->name				= "CH 13 ON";
		properties->variable_address	= &c13;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "13";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 14:	
		properties->name				= "CH 14 ON";
		properties->variable_address	= &c14;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "14";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 15:	
		properties->name				= "CH 15 ON";
		properties->variable_address	= &c15;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "15";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 16:	
		properties->name				= "CH 16 ON";
		properties->variable_address	= &c16;
		properties->datatype_extra		= "range 1,16";
		properties->default_value		= "16";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
   
    
    case 17:
		properties->name				= "MIDI out1";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
    case 18:
		properties->name				= "MIDI out2";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 19:
		properties->name				= "MIDI out3";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 20:
		properties->name				= "MIDI out4";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 21:
		properties->name				= "MIDI out5";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
    case 22:
		properties->name				= "MIDI out6";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 23:
		properties->name				= "MIDI out7";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 24:
		properties->name				= "MIDI out8";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;

		 case 25:
		properties->name				= "MIDI out9";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
    case 26:
		properties->name				= "MIDI out10";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 27:
		properties->name				= "MIDI out11";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 28:
		properties->name				= "MIDI out12";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 29:
		properties->name				= "MIDI out13";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
    case 30:
		properties->name				= "MIDI out14";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 31:
		properties->name				= "MIDI out15";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
		 case 32:
		properties->name				= "MIDI out16";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;

    case 33:
        properties->name                = "INFOS";
        properties->variable_address    = &text_output;
        properties->direction           = DR_OUT;
        properties->datatype            = DT_TEXT; 
        break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}

void Module::OnPlugStateChange(SEPin *pin)
{ 
 sprintf_s(mess, MAX_FILENAME_LENGTH,"1=%d 2=%d 3=%d 4=%d 5=%d 6=%d 7=%d 8=%d 9=%d 10=%d 11=%d 12=%d 13=%d 14=%d 15=%d 16=%d",c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16);
 CallHost(seaudioMasterSetPinOutputText, PN_TEXT_OUT, MAX_FILENAME_LENGTH,(void *) mess );
}
/*
void Module::doaway()
{
     if(err == 0)
	 {
		 fclose( smidifileout);
		 last_take = 0;
	 }
     _unlink(smidi_filename );
     err =  fopen_s(&smidifileout, smidi_filename,"a+b");
}
void Module::loadarray()
{
     if(err == 0)
	 {
		 fclose(smidifileout);
		 last_take = 0;
	 }

     err =  fopen_s(&smidifileout, smidi_filename,"r+b");
	 if(err == 0)
	 {
      
	  int filehandle = _fileno(smidifileout);
      flang = _filelength(filehandle);
	  flang = flang / sizeof(char);
      
         
	  PLAY = false;
      if(tak_note != NULL) delete [] tak_note;
      tak_note = new char [++flang]; 

      unsigned long itaki = 0;
	  while(! feof(smidifileout))
      {
                fread(&ch,sizeof(char ),1,smidifileout);        // MIDI_msg
       tak_note[itaki]= ch;
                itaki++;                                      // next two    
	  }
      last_take = --itaki;
      
	  
      fclose(smidifileout);// THAT WAS THE MIDIFILE 
	  if(admin)
	  {
       sprintf_s(text,400,"%s itaki= %d\n",thisSEM, itaki);
	   diag(text);
	  }
     
	 }
	 REC = false;
     err =  fopen_s(&smidifileout, smidi_filename,"a+b");
}
*/

